package pigGame.model;

public class PigGame {

	public static final int MAX_SCORE = 100;
	
	private Dice d;
	private PigPlayer p1;
	private PigPlayer p2;
	private PigPlayer current;
	
	public PigGame(PigPlayer p1, PigPlayer p2) {
		d = new Dice();
		this.p1 = p1;
		this.p2 = p2;
		current = p1;
	}
	
	public Dice getDice() {
		return d;
	}
	
	public PigPlayer getP1() {
		return p1;
	}
	
	public PigPlayer getP2() {
		return p2;
	}
	
	public PigPlayer getCurrent() {
		return current;
	}	
	
	public void switchTurn() {
		if (current == p1) {
			current = p2;
		} else {
			current = p1;
		}
	}
	
	public boolean p1Turn() {
		return current == p1;
	}
	
	public boolean gameOver() {
		return current.getScore() >= MAX_SCORE;
	}
	
    public boolean roll() {
		d.roll();
		int t = d.getTop();
		current.updateTurn(t);
		if (t == 1) {
			current.resetTurn();
			switchTurn();
			return false;
		}
		return true;
    }
    
    public boolean hold() {
		current.updateScore();
		if (gameOver()) {
			return true;
		}
		switchTurn();
		d.setTop(0);
		return false;
   }

}
